// C/C++ Headers

#include <iostream.h>

// Local Headers

#include "AssignmentComplexNode.h"
#include "ComplexAssignmentStatement.h"
#include "ComplexVariables.h"

AssignmentComplexNode::AssignmentComplexNode(
   const ComplexAssignmentStatement *statement
) :
   mStatement(statement),
   mIsPostAssignment(mStatement->getIsPostAssignment())
{
}

AssignmentComplexNode::~AssignmentComplexNode()
{
   delete (ComplexAssignmentStatement *)mStatement;
}

dcomplex AssignmentComplexNode::evaluate(
   ComplexVariables &cv,
   DoubleVariables &dv,
   ColorEnvironment &env
) const
{
   dcomplex value;

   if(mIsPostAssignment)
      value = cv.get(mStatement->getHandle());

   mStatement->execute(cv, dv, env, NULL, NULL);

   if(!mIsPostAssignment)
      value = cv.get(mStatement->getHandle());

   return(value);
}

ostream &AssignmentComplexNode::print(ostream &out) const
{
   out << "(";
   mStatement->print(out);
   return(out << ")");
}
