// C/C++ Headers

#include <string.h>
#include <iostream.h>

// Local Headers

#include "DoubleAssignmentStatement.h"
#include "DoubleNode.h"
#include "DoubleVariables.h"

DoubleAssignmentStatement::DoubleAssignmentStatement(
   int handle,
   char *name,
   const DoubleNode *ptr,
   int isPostAssignment
) :
   mHandle(handle),
   mName(0),
   mPtr(ptr),
   mIsPostAssignment(isPostAssignment)
{
   mName = new char[strlen(name) + 1];
   strcpy(mName, name);
}

DoubleAssignmentStatement::~DoubleAssignmentStatement()
{
   delete [] mName;
   delete (DoubleNode *)mPtr;
}

int DoubleAssignmentStatement::execute(
   ComplexVariables &cv,
   DoubleVariables  &dv,
   ColorEnvironment &env,
   InfiniteLoopCallback *,
   LoopControl *
) const
{
   dv.set(mHandle, mPtr->evaluate(cv, dv, env));
   return(TRUE);
}

int DoubleAssignmentStatement::getIsPostAssignment() const
{
   return(mIsPostAssignment);
}

int DoubleAssignmentStatement::getHandle() const
{
   return(mHandle);
}

ostream &DoubleAssignmentStatement::print(ostream &out) const
{
   out << "$" << mName << " = ";
   mPtr->print(out);
   return(out);
}
