// C/C++ Headers

#include <string.h>
#include <iostream.h>
#include <iomanip.h>

// Local Headers

#include "DoubleVariablePrintArg.h"
#include "DoubleVariables.h"

DoubleVariablePrintArg::DoubleVariablePrintArg(
   char *variableName, int handle
)  :
   mVariableName(strcpy(new char[strlen(variableName) + 1], variableName)),
   mHandle(handle)
{
}

DoubleVariablePrintArg::~DoubleVariablePrintArg()
{
   delete [] mVariableName;
}

void DoubleVariablePrintArg::execute(
   ComplexVariables &,
   DoubleVariables  &dv,
   ostream &out           
)  const
{
   out << setprecision(10) << dv.get(mHandle);
}

ostream & DoubleVariablePrintArg::print(ostream &out) const
{
   return(out << "$" << mVariableName);
}
