#ifndef _DOUBLE_VARIABLES_H_
#   define _DOUBLE_VARIABLES_H_

class ostream;
struct DoubleEntry;

class DoubleVariables
{
   public:
      DoubleVariables();
      ~DoubleVariables();

      enum { UNDEFINED = -1 };

      int assign(const char *name);
      int lookup(const char *name) const;
      const char *getName(int handle) const;

      void initialize();
      void set(int handle, double value);
      double get(int handle) const;

      ostream &print(ostream &out) const;
      static int main(int argc, char **argv);

      static const double ZERO;

   private:
      DoubleVariables(const DoubleVariables &other);
      DoubleVariables &operator=(const DoubleVariables &other);
      int checkHandle(int handle) const;

      int mCount;
      DoubleEntry **mEntries;
};

ostream &operator<<(ostream &out, const DoubleVariables &cv);

#endif
