// C/C++ Headers

#include <iostream.h>

// Local Headers

#include "UnaryDoubleNode.h"

UnaryDoubleNode::UnaryDoubleNode(const DoubleNode *nodePtr)
   : mNodePtr(nodePtr) {}

UnaryDoubleNode::~UnaryDoubleNode()
{
   delete (DoubleNode *)mNodePtr;
}

double UnaryDoubleNode::evaluate(
   ComplexVariables &cv,
   DoubleVariables &dv,
   ColorEnvironment &env
) const
{
   return(-mNodePtr->evaluate(cv, dv, env));
}

ostream &UnaryDoubleNode::print(ostream &out) const
{
   out << "-";
   mNodePtr->print(out);

   return(out);
}
